c=======================================================================
c     ணࠬ "TEAFDA"   ⨬樨 ࠬ஢ ⭮
c     쭮 ⥭  ⨢ ⠭ ⮤  .
c     (c) RW3FO, 1998-1999.
c-----------------------------------------------------------------------
      program teafda
      parameter (pi=3.141592654)                    !ᥪ⭠ ⠭
      parameter (ifeeders=6)  !⢮  ᮯ⨢ 䨤஢
      implicit complex (x,z)
      complex zz(4,4), xi(4), zel(4)
      complex j /(0.,1.)/
      real feeders(ifeeders) /25.,37.5,50.,75.,300.,600./   ! 䨤஢
      common /maze/ zz,xi,zel,feeder_ro
      common /swr12/ swru1,swru2
      common /pattern_parm/ iplane,iplane_angle,d,h,gph,gabs,fi,pat_max
      namelist /teafda_output/ numb,d,h,gabs,gph,fi,feeder_ro,
     * a_img_zz,u, zz, xi, zel,swru1,swru2,z_alone
      print *, "TEAFDA -- Two Element Active Feed Dipole Antenna",
     * " analysis & optimization."
      print *, "(c) RW3FO, 1998-1999."

      open (1, file='teafda.inp')                           ! 
      read (1,*)
      read (1,*)
      read (1,*) d
      read (1,*) h
      read (1,*) gabs
      read (1,*) gph
      read (1,*)
      read (1,*) shf
      read (1,*) shi
      read (1,*)
      read (1,*) iplane
      read (1,*) iplane_angle
      if (gabs.lt.0..or.gabs.gt.1.) stop '訡  ||'
      if (d.le.0.) stop '訡  d'
      if (h.lt.0..or.h.eq.0.and.gabs.ne.0.) stop '訡  h'
      if (iplane.ne.1.and.iplane.ne.2) stop '訡  ᪮'
      gphase=gph*pi/180.
      zgamma=gabs*cmplx(cos(gphase),sin(gphase))
      close (1)

      fi=pi*(1.-2.*d)+shf*pi/180                  !䠧 ।
      xi(1)=(1.,.0)              !᭠ 㤠 ⮪  
      xi(2)=xi(1)*(1.+shi)*cexp(j*fi)
      xi(3)=xi(1)*zgamma+1e-30
      xi(4)=xi(2)*zgamma+1e-30
      call antenna_pattern ()                                ! 

c      ᨢ ᮯ⨢
      call reciprocal(d,z)        ! ᮯ⨢, ਧ. .
      zz(1,2)=z
      zz(2,1)=z
      zz(3,4)=z
      zz(4,3)=z
      call reciprocal(2*h,z)      ! ᮯ⨢, ਧ. .
      zz(2,4)=z
      zz(4,2)=z
      zz(1,3)=z
      zz(3,1)=z
      call reciprocal(sqrt(d*d+4*h*h),z)  ! ᮯ⨢, .
      zz(1,4)=z
      zz(4,1)=z
      zz(2,3)=z
      zz(3,2)=z

      open (1,file='teafda.out')                     !१ 
      open (2,file='teafda.nml')     !䠩  묨  udistrib.exe

      write (1,*) "TEAFDA (c) RW3FO, 1999"
      write (1,*) "   ⨬樨 ࠬ஢ :"
      write (1,1) "ﭨ  ࠬ     d=",d,"  ;"
      write (1,1) "           h=",h,"  ;"
      write (1,1) "訡  ⭮. ⨬. 祭=",shf," ࠤᮢ;"
      write (1,1) "訡  ⭮. ⨬. 祭=",shi," . .;"
      write (1,1) " - ࠦ   ||=",gabs," "
      write (1,1) "䠧 - ࠦ    arg=",gph," ࠤᮢ;"
      write (1,6) "  䠧 ⮪   Fi=",abs(fi*180./pi)
      write (1,*) "   ࠭ ࠢ,   = ",pat_max

      do iif=1,ifeeders
      feeder_ro=feeders(iif)              ! ᮯ⨢ 䨤
      write (1,5) " ᮯ⨢ 䨤 ", feeder_ro

      a_img_zz=+42.544     ! ⠢  㢮 
      u=swru_avrg(a_img_zz)
      numb=iif*2-1
      write (1,7) numb                           ! ਠ 
      write (1,3) "㢮 :        Z11=",a_img_zz
      write (1,*) "਩ ", u
      write (1,2) "  䠧  0: Z=", zel(1), "=",swru1
      write (1,2) "  䠧 Fi: Z=", zel(2), "=",swru2
      z_alone=zz(1,1)+zz(1,3)*xi(3)/xi(1)     !. ᮯ.  
      write (1,4) " ⢥ : Z=", z_alone
      write (2,nml=teafda_output)

      call minimum_dih(-50.,+100.,.01,a_img_zz,u)      !⨬ 
      numb=iif*2
      write (1,7) numb                           ! ਠ 
      write (1,3) " ⨬쭮 :   Z11=",a_img_zz
      write (1,*) "਩ ", u
      write (1,2) "  䠧  0: Z=", zel(1), "=",swru1
      write (1,2) "  䠧 Fi: Z=", zel(2), "=",swru2
      z_alone=zz(1,1)+zz(1,3)*xi(3)/xi(1)     !. ᮯ.  
      write (1,4) " ⢥ : Z=", z_alone
      write (2,nml=teafda_output)

      enddo

      close(1)
      close(2)

1     format (8x, a35, f8.3,a)
2     format (1x, a, f6.1, ' j', f6.1, '   ', a, f4.1)
3     format (a, ' j', f6.1, ' ')
4     format (a, f6.1, ' j', f6.1, ' ')
5     format (72('=')/, a, f5.1, ' '/, 72('-'))
6     format (/ a37, f6.1, ' ࠤ()'/)
7     format (61x, 'ਠ', i4)
      stop '...⮢.  - teafda.out, teafda.nml, pattern.dat'
      end
c=======================================================================
c      㬠 㭪樨 swru_avrg(a_zimg) ⮤ 
c-----------------------------------------------------------------------
      subroutine minimum_dih(a,b,eps,xmax,ymax)
30    continue
      if (abs(b-a).lt.2.*eps) goto 100
      c=(a+b-eps)/2.
      d=(a+b+eps)/2.
      ak=-1.*swru_avrg(c)
      al=-1.*swru_avrg(d)
      if (ak.gt.al) goto 90
      a=c
      goto 30
90    b=d
      goto 30
100   xmax=(a+b)/2.
      ymax=swru_avrg(xmax)
      return
      end
c=======================================================================
c     ᫥ ᮡ⢥ ᮯ⨢ ஢ zz(i,i);
c     ᫥ 室 ᮯ⨢ ஢ zel(i);
c     ᫥   䨤 swru1, swru2;
c     ᫥ । ᪮ 祭  swru_avrg.
c-----------------------------------------------------------------------
      function swru_avrg(a_zimg)
      implicit complex (x,z)
      complex zz(4,4), xi(4), zel(4)
      common /maze/ zz,xi,zel,feeder_ro
      common /swr12/ swru1,swru2
       z=cmplx(73.13,a_zimg)        !ᮡ⢥ ᮯ⨢ 
       zz(1,1)=z
       zz(2,2)=z
       zz(3,3)=z
       zz(4,4)=z
             do m=1,4                   !室 ᮯ⨢ 
              z=(0.,0.)
              do n=1,4
                       z=z+zz(m,n)*xi(n)/xi(m)
              enddo
              zel(m)=z
             enddo

       call swru(feeder_ro,zel(1),swru1,t1,t2)!  䨤  1
       call swru(feeder_ro,zel(2),swru2,t1,t2)!  䨤  2
      swru_avrg=sqrt((swru1**2+swru2**2)/2.)     !਩: . . 
c     swru_avrg=abs(swru1-swru2)              !਩:  ࠧ
      return
      end
c=======================================================================
c     ணࠬ-㭪 ᫥ । ⥣ࠫ
c      㭪樨, ᮤঠ饩  ணࠬ-㭪樨 fun_gint(x)
c      ।  a  b  筮 eps ⮤ 
c-----------------------------------------------------------------------
      subroutine reciprocal(ro,zreci)
      implicit complex (z)
             ro2=ro*ro
             a=1e-20                             ! । ⥣஢
             b=.25                               ! । ⥣஢
             eps=1e-6                                         ! 筮
             m=1                                              ! Im-
             ak=0.
40           continue
             m=m*2
             qa=a
             t=sqrt(.6)
             ai=0.
             h=(b-qa)/m
             do j=1,m
              w=qa+h
              c=(w+qa)/2.
              d=(w-qa)/2.
              e=d*5./9.
              al=d*8./9.
              d=d*t
              x=c-d
              ai=ai+e*fun_gint_image(x,ro2)
              x=c
              ai=ai+al*fun_gint_image(x,ro2)
              x=c+d
              ai=ai+e*fun_gint_image(x,ro2)
              qa=w
             enddo
             al=ak
             ak=ai
              if(abs(ai-al).gt.eps) go to 40
      gint_image=60.*ai
             m=1                                              ! Re-
             ak=0.
50           continue
             m=m*2
             qa=a
             t=sqrt(.6)
             ai=0.
             h=(b-qa)/m
             do j=1,m
              w=qa+h
              c=(w+qa)/2.
              d=(w-qa)/2.
              e=d*5./9.
              al=d*8./9.
              d=d*t
              x=c-d
              ai=ai+e*fun_gint_real(x,ro2)
              x=c
              ai=ai+al*fun_gint_real(x,ro2)
              x=c+d
              ai=ai+e*fun_gint_real(x,ro2)
              qa=w
             enddo
             al=ak
             ak=ai
              if(abs(ai-al).gt.eps) go to 50
      gint_real=60.*ai
      zreci=cmplx(gint_real,gint_image)
      return
      end
c=======================================================================
c     ணࠬ-㭪  ⥣஢  gint(a,b,eps) Im-
c-----------------------------------------------------------------------
      function fun_gint_image(z,ro2)
             parameter(pi2= 6.283185)
             r1= sqrt(ro2+ (z-.25)**2)
             r2= sqrt(ro2+ (z+.25)**2)
             f= cos(pi2*r1)/r1 + cos(pi2*r2)/r2
      fun_gint_image= f* sin(pi2*(.25-z))
      return
      end
c=======================================================================
c     ணࠬ-㭪  ⥣஢  gint(a,b,eps) Re-
c-----------------------------------------------------------------------
      function fun_gint_real(z,ro2)
             parameter(pi2= 6.283185)
             r1= sqrt(ro2+ (z-.25)**2)
             r2= sqrt(ro2+ (z+.25)**2)
             f= sin(pi2*r1)/r1 + sin(pi2*r2)/r2
      fun_gint_real= f* sin(pi2*(.25-z))
      return
      end
c=======================================================================
c     ᫥ न coord_real  祭 ᮯ⨢
c     resistivity_real  襩 筮 (㧫)   s  
c       ᮯ⨢ ro  ᭮ 㧪 zl
c-----------------------------------------------------------------------
      subroutine swru (ro,zl,s,coord_real,resistivity_real)
      implicit complex (z)
      eps=1e-6                                                 !筮
      a=-eps
      b=.25+eps    !  1/4  , .. 襣 ६㬠
      call impedance (ro,a,zi,zl) !஢ઠ     
      f=aimag(zi)
      factor=1.
      if(f.gt.0.) factor=-1.                  !㭪 -- ஢!
      do while((b-a).gt.eps)               ! 祭 "c"  Im(zi)=0
              c=(a+b)/2.
              call impedance (ro,c,zi,zl)
              f=factor*aimag(zi)
              if(f.gt.0.) then
                               b=c
                          else
                               a=c
              end if
      enddo
      coord_real=c                               ! ᠬ 襥 ""
      resistivity_real = real(zi)       ! ᠬ ⨢ ᮯ⨢
      s=resistivity_real/ro                                        !
      if (s.ge.1.) then
                           return
                   else
                           s=1./(s+1e-30)
                           return
      end if
      end
c=======================================================================
c     ணࠬ ᫥ 室 ᮯ⨢ 
c-----------------------------------------------------------------------
      subroutine impedance (ro,al,zi,zl)
      implicit complex (z)
      complex j /(0.,1.)/
      tg=tan(6.2831853*al)
      zi=(zl+j*ro*tg)/(1.+j*zl*tg/ro)
      return
      end
c=======================================================================
c     ணࠬ  ࠬ ࠢ ⥭
c-----------------------------------------------------------------------
      subroutine antenna_pattern ()
      parameter (pi=3.141592654)                    !ᥪ⭠ ⠭
      implicit complex (x,z)
      complex zz(4,4), xi(4), zel(4)
      real c(4,3), ptn(0:360)
      common /maze/ zz,xi,zel,feeder_ro
      common /pattern_parm/ iplane,iplane_angle,d,h,gph,gabs,fi,pat_max
             c(1,1)= 0.   !X1                !न ⮢ (xyz)
             c(1,2)= d/2  !Y1
             c(1,3)= h    !Z1
             c(2,1)= 0.   !X2
             c(2,2)=-d/2  !Y2
             c(2,3)= h    !Z2
             c(3,1)= 0.   !X3
             c(3,2)= d/2  !Y3
             c(3,3)=-h    !Z3
             c(4,1)= 0.   !X4
             c(4,2)=-d/2  !Y4
             c(4,3)=-h    !Z4
      pat_max=-1e31

      select case (iplane)
c-----------------------------------------------------------------------
      case (1)                   !   ਧ⠫쭮 ᪮

      limit_angle=360                                !।  
      th=iplane_angle*pi/180       !ࠬ -- 㣮   . .
      do iangle= 0, limit_angle                  !  ਧ. ᪮
             al=pi*iangle/180
             z1=z_array(al,th,4,c,xi)
             d1=dipole(al,th)
             z2=z1*z2
             d2=cabs(dipole(al,th)*z_array(al,th,4,c,xi))
             d3=20*alog10(1e-30+d2)
             ptn(iangle)= 20*alog10(1e-30+cabs(
     *                    dipole(al,th)*z_array(al,th,4,c,xi) ))
             pat_max= amax1( ptn(iangle), pat_max )
      enddo

      open(1, file='pattern.dat')          !䠩 १⮢  
      do iangle=0, limit_angle
       write(1,*) iangle, ptn(iangle)-pat_max
      enddo
      close(1)
c-----------------------------------------------------------------------
      case (2)                     !   ⨪쭮 ᪮

      limit_angle=180                                !।  
      if (gabs.eq.0.) limit_angle=360                     ! 

      al=iplane_angle*pi/180      !ࠬ -- 㣮   ਧ. .
      do iangle= 0, limit_angle                   !  . ᪮
             th=pi*iangle/180
             ptn(iangle)= 20*alog10(1e-30+cabs(
     *                    dipole(al,th)*z_array(al,th,4,c,xi) ))
             pat_max= amax1( ptn(iangle), pat_max )
      enddo

      open(1, file='pattern.dat')          !䠩 १⮢  
      do iangle=0, limit_angle
       write(1,*) iangle, ptn(iangle)-pat_max
      enddo
      close(1)

      end select
      return
      end
c=======================================================================
c      ᫥ ⥫ ⪨  nelement ⮢,
c     ᯮ  窠 c(i,3), ᭠ 㤠 ⮪
c      z_currents(i). ࠢ - al- ⭮⥫쭮
c      OY, th-㣮  ⭮⥫쭮 ᪮ XOY.
c-----------------------------------------------------------------------
      function z_array (al, th, nelement, c, z_currents)
      implicit complex (z)
      dimension c(nelement,3), z_currents(nelement)
      z_array=(0.,0.)
      do i=1, nelement
       d = c(i,1)*cos(th)*sin(al)+c(i,2)*cos(th)*cos(al)+c(i,3)*sin(th)
       z_array = z_array + z_currents(i)*cexp((0.,6.283185)*d)
      enddo
      return
      end
c=======================================================================
c      㢮 
c-----------------------------------------------------------------------
      function dipole (al, th)
      dipole=1.2817*(sin(acos(cos(th)*sin(al))))**2
c     dipole=1.
      return
      end
c=======================================================================